

static char *basetypename(int t)
{
  static char buf[200];
  buf[0]= 0;
  switch(TYPEbas(t))
  {
  case 'i': 
     if (TYPEwid(t)==8) sprintf(buf,"char");
     else sprintf(buf,"int%d_t", TYPEwid(t)); break;
  case 'u': 
     if (TYPEwid(t)==8) sprintf(buf,"unsigned char");
     else 
     sprintf(buf,"uint%d_t", TYPEwid(t)); break;
  case 'f': if (TYPEwid(t)<=32) sprintf(buf,"float"); 
                           else sprintf(buf,"double"); break;
  }
  return buf;
}

void method_proto(FILE *out, method_t *M,char *retv, char *pfx, char *term)
{
  int a;
  char *n;
  int t; char *p;

  fprintf(out,"%s %s(",retv,M->name);
  p= "";
  for(a=0;a<M->nargs;a++)
  {
    t= M->args[a]->type;
    n= M->args[a]->name;
    if (TYPEcom(t)=='a') { fprintf(out,"%suint32_t %s%s",p, pfx, n); p= ","; }
    fprintf(out,"%s%s", p, basetypename(t)); p= ",";
    if (TYPEcom(t)!='.') fprintf(out,"* ");  else fprintf(out," ");
    fprintf(out,"%s", n);
  }
  fprintf(out,") %s\n", term);
}


void mcall_proto(FILE *out, method_t *M,char *pfx, char *term)
{
  method_proto(out, M, "int", pfx, term);
}
void mdisp_proto(FILE *out, method_t *M,char *pfx, char *term)
{
  method_proto(out, M, "void", pfx, term);
}


void gen_mcall(FILE *out, method_t *M)
{
  int a;
  char *n;
  int t;

  mcall_proto(out, M, "_LEN", "\n{");

  fprintf(out,"  uint32_t _LEN;\n");
  fprintf(out,"  uint8_t *_OUT;\n");
  fprintf(out,"  uint32_t _OFF;\n");
  // send length
  // send message code
  // send arguments
  for(a=0;a<M->nargs;a++)
  {
    t= M->args[a]->type; n= M->args[a]->name;
    if (TYPEcom(t)=='s')
     fprintf(out,"  uint32_t _LEN%s= strlen%c%d(%s);\n", n, TYPEbas(t), TYPEwid(t), n);
  }

  fprintf(out,"  _LEN= 8; // length and mcode fields \n");
  for(a=0;a<M->nargs;a++)
  {
     t= M->args[a]->type; n= M->args[a]->name;
     if (TYPEcom(t)=='.')
     {
       if (TYPEwid(t)<=32) fprintf(out,"  _LEN+= 4; // %s\n",n);
                     else  fprintf(out,"  _LEN+= PAD8(_LEN)+8; // %s\n",n);
     }
     else
       fprintf(out,"  _LEN+= 4; // L%s\n",n);  // for the length field.
  }
  for(a=0;a<M->nargs;a++)
  {
    t= M->args[a]->type; n= M->args[a]->name;
    if (TYPEcom(t)=='.') continue;
    if (TYPEwid(t)<=32) 
       fprintf(out,"  _LEN+= PAD4(_LEN)+_LEN%s*%d;\n",
                    n, TYPEwid(t)/8);         
    else
       fprintf(out,"  _LEN+= PAD8(_LEN)+_LEN%s*%d;\n",
                    n, TYPEwid(t)/8);         
  }
  
  fprintf(out,"  _OUT= _OBUF;\n");
  fprintf(out,"  *(uint32_t*) _OUT= _LEN; _OUT+= 4;\n");
  fprintf(out,"  *(uint32_t*) _OUT= %d; _OUT+= 4;\n", M->code);

  for(a=0;a<M->nargs;a++)
  {
     t= M->args[a]->type; n= M->args[a]->name;
     if (TYPEcom(t)=='.')
     {
       if (TYPEwid(t)<=32)
          fprintf(out,"  *(%s*) _OUT= %s; _OUT+= 4;\n",basetypename(t),n);
       else 
       {
          fprintf(out,"  _OUT+= PAD8(_OUT-_OBUF);\n");
          fprintf(out,"  *(%s*) _OUT= %s; _OUT+= 8;\n",basetypename(t),n);
       }
     }
     else
       fprintf(out,"  *(uint32_t*) _OUT= _LEN%s; _OUT+= 4;\n",n); 
  }
  fprintf(out,"  _OFF= _OUT-_OBUF;\n");
  fprintf(out,"  if (OSEND(_OBUF, _OFF, 0, 4)<0) return 1;\n");
  for(a=0;a<M->nargs;a++)
  {
     int p;
     t= M->args[a]->type; n= M->args[a]->name;
     if (TYPEcom(t)=='.') continue;
     if (TYPEwid(t)<=32) p= 4; else p= 8;
     fprintf(out,"  if ((_OFF = OSEND(%s, _LEN%s*%d, _OFF, %d))<0) return 1;\n", 
                            n, n, TYPEwid(t)/8, p);
  }
  fprintf(out,"  return 0;\n");
  fprintf(out,"}\n");
}


void gen_mdisp(FILE *out,method_t *M)
{
  int a, t;  char *n,*p;
  fprintf(out,"static void _DISP%d()\n{\n", M->code);
  if (!M->nargs) goto noargs;
  fprintf(out,"static uint8_t *_INP;\n");
  for(a=0;a<M->nargs;a++)
  {
     t= M->args[a]->type; n= M->args[a]->name;
     fprintf(out, "  %s", basetypename(t));
     if (TYPEcom(t)=='.') fprintf(out," ");
                     else fprintf(out,"* ");
     fprintf(out," %s;\n", n);
     if (TYPEcom(t)!='.') fprintf(out,"  uint32_t L%s;\n", n);
  }

  fprintf(out,"  _INP= _IBUF+8; // skip length+mcode\n");
  for(a=0;a<M->nargs;a++)
  {
     t= M->args[a]->type; n= M->args[a]->name;
     if (TYPEcom(t)=='.')
     {
       if (TYPEwid(t)>32) 
       {
         fprintf(out,"  _INP+= PAD8(_INP-_IBUF); ");
         fprintf(out,"  %s= *(%s*)_INP; _INP+= 8;\n",n, basetypename(t));
       } else
          fprintf(out,"  %s= *(%s*)_INP; _INP+= 4;\n",n, basetypename(t));
     }
     else
       fprintf(out,"  L%s= *(uint32_t*)_INP; _INP+= 4;\n",n); 
  }
  for(a=0;a<M->nargs;a++)
  {
     int p;
     t= M->args[a]->type; n= M->args[a]->name;
     if (TYPEcom(t)=='.') continue;
     if (TYPEwid(t)<=32) p= 4; else p= 8;
     fprintf(out,"  _INP+= PAD%d(_INP-_IBUF); %s= (%s*) _INP; _INP+= L%s*%d;\n",
                p, n, basetypename(t), n, TYPEwid(t)/8); 
  }

noargs:
  fprintf(out,"  %s(", M->name);
  p= "";
  for(a=0;a<M->nargs;a++)
  {
     t= M->args[a]->type; n= M->args[a]->name;
     if (TYPEcom(t)=='a') { fprintf(out,"%sL%s", p, n); p= ","; }
     fprintf(out,"%s%s", p,n); p= ",";
  }
  fprintf(out,");\n");
  fprintf(out,"}\n");
}

void gen_dispatch(FILE *out,proc_t *P)
{
  int i;
  for(i=0;i<P->nmethods;i++)
    gen_mdisp(out, P->methods[i]);
  fprintf(out,"static void _DISPATCH()\n{\n");
  fprintf(out,"  uint32_t mcode;\n");
  fprintf(out,"  mcode= *(uint32_t*) (_IBUF+4);\n");
  fprintf(out,"  switch(mcode)\n  {\n");
  for(i=0;i<P->nmethods;i++)
  {
    fprintf(out,"    case %d: _DISP%d(); break;\n", 
       P->methods[i]->code,
       P->methods[i]->code);
  }
  fprintf(out,"  }\n}\n");
}


void Gproto_peerfunc(FILE *out, proc_t *P, int nALL, proc_t **ALL)
{
  int i,j;
  proc_t *K;
  fprintf(out,
"/************************************************************************\n"
" *   Functions implemented on the other side. Call these to run         *\n"
" *   code on the other machine.                                         *\n"
" ***********************************************************************/\n");
  for(i=0;i<nALL;i++)
  {
    K= ALL[i];
    if (K==P) continue;
    for(j=0;j<K->nmethods;j++)
      mcall_proto(out, K->methods[j], "L", ";");
  }
}

void Gproto_selffunc(FILE *out,proc_t *P)
{
  int i;
  fprintf(out,
"/************************************************************************\n"
" *   Functions implemented on this side. Implement these functions      *\n"
" *   in this program. The peer will cause these to be called.           *\n"
" ***********************************************************************/\n");
  for(i=0;i<P->nmethods;i++)
  {
    mdisp_proto(out, P->methods[i], "L", ";");
  }
}

void Gheader(proc_t *P, int nALL, proc_t **ALL)
{
  fprintf(P->header,
"/*** IPF header file for process %s ***/\n", P->name);
  fputs(
#include "lib01.hx"
       , P->header);
  Gproto_selffunc(P->header, P);
  Gproto_peerfunc(P->header, P, nALL, ALL);
}

void Gsource(proc_t *P, int nALL, proc_t **ALL)
{
  proc_t *K;
  int i,j;
  fprintf(P->source,
"/*** IPF source file for process %s ***/\n", P->name);
  fprintf(P->source,
"#define _OBUFSIZE %d\n", maxobufsize);
  fputs(
#include "lib01.cx"
       , P->source);
  Gproto_selffunc(P->source, P);
  gen_dispatch(P->source, P);
  for(i=0;i<nALL;i++)
  {
    K= ALL[i];
    if (K==P) continue;
    for(j=0;j<K->nmethods;j++)
      gen_mcall(P->source, K->methods[j]);
  }
}


