#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "ptrbuf.h"
#include "proc.h"
#include "lexer.h"
#include "parse.h"

int maxobufsize;
#include "genout.c"



void enum_methods(size_t nP, proc_t **P)
{
  size_t i,j,k;
  k= 1;
  for(i=0;i<nP;i++)
    for(j=0;j<P[i]->nmethods;j++)
      P[i]->methods[j]->code= k++;      
}

void open_files(proc_t *P)
{
  if (!P->header_fn) 
      exit(fprintf(stderr,"no header given for process %s\n",P->name));
  if (!(P->header=fopen(P->header_fn,"wb")))
      exit(fprintf(stderr,"can not open file %s\n",P->header_fn));
  if (!P->source_fn) 
      exit(fprintf(stderr,"no source given for process %s\n",P->name));
  if (!(P->source=fopen(P->source_fn,"wb")))
      exit(fprintf(stderr,"can not open file %s\n",P->source_fn));
}


void compute_max_obufsize(int nP,proc_t **P)
{
  int max4, max8;
  int arg4, arg8;
  int i,j,a,t;
  proc_t *K;
  method_t *M;
  max8= max4= 0;
  for(i=0;i<nP;i++)
  {
    K= P[i];
    for(j=0;j<K->nmethods;j++)
    {
      M= K->methods[j];
      arg4= arg8= 0;
      for(a=0;a<M->nargs;a++)
      {
        t= M->args[a]->type;
        if (TYPEcom(t)=='.')
        {
          if (TYPEwid(t)<=32) arg4++; else arg8++;
        } else arg4++;
      }
      if (arg4>max4) max4= arg4;
      if (arg8>max8) max8= arg8;
    }
  }
  maxobufsize= 8 + max4*4 + max8*12;
}


int main(int argc,char **argv)
{
  proc_t **P;
  size_t nP,i;

  parse_file(argv[1],&nP, &P);
  enum_methods(nP, P);
  compute_max_obufsize(nP,P);

  for(i=0;i<nP;i++) open_files(P[i]);
  for(i=0;i<nP;i++) 
  {
    Gheader(P[i], nP, P);
    Gsource(P[i], nP, P);
  }

  return 0;
}
